﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SD.LLBLGen.Pro.ORMSupportClasses;

namespace XamDataGridSelectActiveRow
{
    /// <summary>Factory to create new, empty DerdeBeheerderStraatEntity objects.</summary>
    [Serializable]
    public partial class DerdeBeheerderStraatEntityFactory : EntityFactoryBase2<DerdeBeheerderStraatEntity>
    {
        /// <summary>CTor</summary>
        public DerdeBeheerderStraatEntityFactory() : base("DerdeBeheerderStraatEntity", EntityType.DerdeBeheerderStraatEntity, false) { }

        /// <summary>Creates a new DerdeBeheerderStraatEntity instance but uses a special constructor which will set the Fields object of the new IEntity2 instance to the passed in fields object.</summary>
        /// <param name="fields">Populated IEntityFields2 object for the new IEntity2 to create</param>
        /// <returns>Fully created and populated (due to the IEntityFields2 object) IEntity2 object</returns>
        public override IEntity2 Create(IEntityFields2 fields)
        {
            IEntity2 toReturn = new DerdeBeheerderStraatEntity(fields);
            // __LLBLGENPRO_USER_CODE_REGION_START CreateNewDerdeBeheerderStraatUsingFields
            // __LLBLGENPRO_USER_CODE_REGION_END
            return toReturn;
        }
        #region Included Code

        #endregion
    }
    // __LLBLGENPRO_USER_CODE_REGION_START AdditionalNamespaces
    // __LLBLGENPRO_USER_CODE_REGION_END

    /// <summary>general base class for the generated factories</summary>
    [Serializable]
    public partial class EntityFactoryBase2<TEntity> : EntityFactoryCore2
        where TEntity : EntityBase2, IEntity2
    {
        private readonly EntityType _typeOfEntity;
        private readonly bool _isInHierarchy;

        /// <summary>CTor</summary>
        /// <param name="entityName">Name of the entity.</param>
        /// <param name="typeOfEntity">The type of entity.</param>
        /// <param name="isInHierarchy">If true, the entity of this factory is in an inheritance hierarchy, false otherwise</param>
        public EntityFactoryBase2(string entityName, EntityType typeOfEntity, bool isInHierarchy)
            : base(entityName)
        {
            _typeOfEntity = typeOfEntity;
            _isInHierarchy = isInHierarchy;
        }

        /// <summary>Creates, using the generated EntityFieldsFactory, the IEntityFields2 object for the entity to create.</summary>
        /// <returns>Empty IEntityFields2 object.</returns>
        public override IEntityFields2 CreateFields()
        {
            return EntityFieldsFactory.CreateEntityFieldsObject(_typeOfEntity);
        }

        /// <summary>Creates a new entity instance using the GeneralEntityFactory in the generated code, using the passed in entitytype value</summary>
        /// <param name="entityTypeValue">The entity type value of the entity to create an instance for.</param>
        /// <returns>new IEntity instance</returns>
        public override IEntity2 CreateEntityFromEntityTypeValue(int entityTypeValue)
        {
            return GeneralEntityFactory.Create((EntityType)entityTypeValue);
        }

        /// <summary>Creates the relations collection to the entity to join all targets so this entity can be fetched. </summary>
        /// <param name="objectAlias">The object alias to use for the elements in the relations.</param>
        /// <returns>null if the entity isn't in a hierarchy of type TargetPerEntity, otherwise the relations collection needed to join all targets together to fetch all subtypes of this entity and this entity itself</returns>
        public override IRelationCollection CreateHierarchyRelations(string objectAlias)
        {
            return InheritanceInfoProviderSingleton.GetInstance().GetHierarchyRelations(this.ForEntityName, objectAlias);
        }

        /// <summary>This method retrieves, using the InheritanceInfoprovider, the factory for the entity represented by the values passed in.</summary>
        /// <param name="fieldValues">Field values read from the db, to determine which factory to return, based on the field values passed in.</param>
        /// <param name="entityFieldStartIndexesPerEntity">indexes into values where per entity type their own fields start.</param>
        /// <returns>the factory for the entity which is represented by the values passed in.</returns>
        public override IEntityFactory2 GetEntityFactory(object[] fieldValues, Dictionary<string, int> entityFieldStartIndexesPerEntity)
        {
            IEntityFactory2 toReturn = (IEntityFactory2)InheritanceInfoProviderSingleton.GetInstance().GetEntityFactory(this.ForEntityName, fieldValues, entityFieldStartIndexesPerEntity);
            if (toReturn == null)
            {
                toReturn = this;
            }
            return toReturn;
        }

        /// <summary>Gets a predicateexpression which filters on the entity with type belonging to this factory.</summary>
        /// <param name="negate">Flag to produce a NOT filter, (true), or a normal filter (false). </param>
        /// <param name="objectAlias">The object alias to use for the predicate(s).</param>
        /// <returns>ready to use predicateexpression, or an empty predicate expression if the belonging entity isn't a hierarchical type.</returns>
        public override IPredicateExpression GetEntityTypeFilter(bool negate, string objectAlias)
        {
            return InheritanceInfoProviderSingleton.GetInstance().GetEntityTypeFilter(this.ForEntityName, objectAlias, negate);
        }

        /// <summary>Creates a new generic EntityCollection(Of T) for the entity which this factory belongs to.</summary>
        /// <returns>ready to use generic EntityCollection(Of T) with this factory set as the factory</returns>
        public override IEntityCollection2 CreateEntityCollection()
        {
            return new EntityCollection<TEntity>(this);
        }

        /// <summary>Creates the hierarchy fields for the entity to which this factory belongs.</summary>
        /// <returns>IEntityFields2 object with the fields of all the entities in teh hierarchy of this entity or the fields of this entity if the entity isn't in a hierarchy.</returns>
        public override IEntityFields2 CreateHierarchyFields()
        {
            return _isInHierarchy ? new EntityFields2(InheritanceInfoProviderSingleton.GetInstance().GetHierarchyFields(this.ForEntityName), InheritanceInfoProviderSingleton.GetInstance(), null) : base.CreateHierarchyFields();
        }
    }
    /// <summary>Enum definition for all the entity types defined in this namespace. Used by the entityfields factory.</summary>
    public enum EntityType
    {
        ///<summary>DerdeBeheerderAdres</summary>
        DerdeBeheerderAdresEntity,
        ///<summary>DerdeBeheerderAdresPartij</summary>
        DerdeBeheerderAdresPartijEntity,
        ///<summary>DerdeBeheerderDlgmt</summary>
        DerdeBeheerderDlgmtEntity,
        ///<summary>DerdeBeheerderStraat</summary>
        DerdeBeheerderStraatEntity,
        ///<summary>DerdeBeheerderTelecom</summary>
        DerdeBeheerderTelecomEntity,
        ///<summary>DerdeBeheerderTelecomPartij</summary>
        DerdeBeheerderTelecomPartijEntity
    }
    /// <summary>Factory to create new, empty Entity objects based on the entity type specified. Uses  entity specific factory objects</summary>
    [Serializable]
    public partial class GeneralEntityFactory
    {
        /// <summary>Creates a new, empty Entity object of the type specified</summary>
        /// <param name="entityTypeToCreate">The entity type to create.</param>
        /// <returns>A new, empty Entity object.</returns>
        public static IEntity2 Create(EntityType entityTypeToCreate)
        {
            IEntityFactory2 factoryToUse = null;
            switch (entityTypeToCreate)
            {
                case EntityType.DerdeBeheerderStraatEntity:
                    factoryToUse = new DerdeBeheerderStraatEntityFactory();
                    break;
            }
            IEntity2 toReturn = null;
            if (factoryToUse != null)
            {
                toReturn = factoryToUse.Create();
            }
            return toReturn;
        }
    }
}
