﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SD.LLBLGen.Pro.ORMSupportClasses;

namespace XamDataGridSelectActiveRow
{
    public partial class DerdeBeheerderStraatRelations
    {
        /// <summary>CTor</summary>
        public DerdeBeheerderStraatRelations()
        {
        }

        /// <summary>Gets all relations of the DerdeBeheerderStraatEntity as a list of IEntityRelation objects.</summary>
        /// <returns>a list of IEntityRelation objects</returns>
        public virtual List<IEntityRelation> GetAllRelations()
        {
            List<IEntityRelation> toReturn = new List<IEntityRelation>();
            return toReturn;
        }

        #region Class Property Declarations

        /// <summary>stub, not used in this entity, only for TargetPerEntity entities.</summary>
        public virtual IEntityRelation GetSubTypeRelation(string subTypeEntityName) { return null; }
        /// <summary>stub, not used in this entity, only for TargetPerEntity entities.</summary>
        public virtual IEntityRelation GetSuperTypeRelation() { return null; }
        /// <summary>Returns a new IEntityRelation object, between DerdeBeheerderStraatEntity and DerdeBeheerderAdresEntity over the 1:n relation they have, using the relation between the fields:
        /// DerdeBeheerderStraat.Id - DerdeBeheerderAdres.StraatId
        /// </summary>
        public virtual IEntityRelation DerdeBeheerderAdresEntityUsingStraatId
        {
            get
            {
                IEntityRelation relation = new EntityRelation(SD.LLBLGen.Pro.ORMSupportClasses.RelationType.OneToMany, "", true);
                return relation;
            }
        }
        #endregion

        #region Included Code

        #endregion
    }

    /// <summary>Static class which is used for providing relationship instances which are re-used internally for syncing</summary>
    internal static class StaticDerdeBeheerderStraatRelations
    {
        internal static readonly IEntityRelation DerdeBeheerderAdresEntityUsingStraatIdStatic = new DerdeBeheerderStraatRelations().DerdeBeheerderAdresEntityUsingStraatId;

        /// <summary>CTor</summary>
        static StaticDerdeBeheerderStraatRelations()
        {
        }
    }
    /// <summary>Field Creation Class for entity DerdeBeheerderStraatEntity</summary>
    public partial class DerdeBeheerderStraatFields
    {
        /// <summary>Creates a new DerdeBeheerderStraatEntity.DtTot field instance</summary>
        public static EntityField2 DtTot
        {
            get { return (EntityField2)EntityFieldFactory.Create(DerdeBeheerderStraatFieldIndex.DtTot); }
        }
        /// <summary>Creates a new DerdeBeheerderStraatEntity.DtWijz field instance</summary>
        public static EntityField2 DtWijz
        {
            get { return (EntityField2)EntityFieldFactory.Create(DerdeBeheerderStraatFieldIndex.DtWijz); }
        }
        /// <summary>Creates a new DerdeBeheerderStraatEntity.HistInd field instance</summary>
        public static EntityField2 HistInd
        {
            get { return (EntityField2)EntityFieldFactory.Create(DerdeBeheerderStraatFieldIndex.HistInd); }
        }
        /// <summary>Creates a new DerdeBeheerderStraatEntity.Id field instance</summary>
        public static EntityField2 Id
        {
            get { return (EntityField2)EntityFieldFactory.Create(DerdeBeheerderStraatFieldIndex.Id); }
        }
        /// <summary>Creates a new DerdeBeheerderStraatEntity.OldId field instance</summary>
        public static EntityField2 OldId
        {
            get { return (EntityField2)EntityFieldFactory.Create(DerdeBeheerderStraatFieldIndex.OldId); }
        }
        /// <summary>Creates a new DerdeBeheerderStraatEntity.PostCd field instance</summary>
        public static EntityField2 PostCd
        {
            get { return (EntityField2)EntityFieldFactory.Create(DerdeBeheerderStraatFieldIndex.PostCd); }
        }
        /// <summary>Creates a new DerdeBeheerderStraatEntity.Straat field instance</summary>
        public static EntityField2 Straat
        {
            get { return (EntityField2)EntityFieldFactory.Create(DerdeBeheerderStraatFieldIndex.Straat); }
        }
        /// <summary>Creates a new DerdeBeheerderStraatEntity.StraatCd field instance</summary>
        public static EntityField2 StraatCd
        {
            get { return (EntityField2)EntityFieldFactory.Create(DerdeBeheerderStraatFieldIndex.StraatCd); }
        }
        /// <summary>Creates a new DerdeBeheerderStraatEntity.TaalCd field instance</summary>
        public static EntityField2 TaalCd
        {
            get { return (EntityField2)EntityFieldFactory.Create(DerdeBeheerderStraatFieldIndex.TaalCd); }
        }
        /// <summary>Creates a new DerdeBeheerderStraatEntity.UsidWijz field instance</summary>
        public static EntityField2 UsidWijz
        {
            get { return (EntityField2)EntityFieldFactory.Create(DerdeBeheerderStraatFieldIndex.UsidWijz); }
        }
    }
    public static partial class EntityFieldFactory
    {
        /// <summary>Creates a new IEntityField2 instance for usage in the EntityFields object for the entity related to the field index specified.</summary>
        /// <param name="fieldIndex">The field which IEntityField2 instance should be created</param>
        /// <returns>The IEntityField2 instance for the field specified in fieldIndex</returns>
        public static IEntityField2 Create(Enum fieldIndex)
        {
            return new EntityField2(FieldInfoProviderSingleton.GetInstance().GetFieldInfo(fieldIndex));
        }

        /// <summary>Creates a new IEntityField2 instance, which represents the field objectName.fieldName</summary>
        /// <param name="objectName">the name of the object the field belongs to, like CustomerEntity or OrdersTypedView</param>
        /// <param name="fieldName">the name of the field to create</param>
        public static IEntityField2 Create(string objectName, string fieldName)
        {
            return new EntityField2(FieldInfoProviderSingleton.GetInstance().GetFieldInfo(objectName, fieldName));
        }

        #region Included Code

        #endregion
    }
    // __LLBLGENPRO_USER_CODE_REGION_START AdditionalNamespaces
    // __LLBLGENPRO_USER_CODE_REGION_END

    /// <summary>Singleton implementation of the FieldInfoProvider. This class is the singleton wrapper through which the actual instance is retrieved.</summary>
    /// <remarks>It uses a single instance of an internal class. The access isn't marked with locks as the FieldInfoProviderBase class is threadsafe.</remarks>
    internal static class FieldInfoProviderSingleton
    {
        #region Class Member Declarations
        private static readonly IFieldInfoProvider _providerInstance = new FieldInfoProviderCore();
        #endregion

        /// <summary>Dummy static constructor to make sure threadsafe initialization is performed.</summary>
        static FieldInfoProviderSingleton()
        {
        }

        /// <summary>Gets the singleton instance of the FieldInfoProviderCore</summary>
        /// <returns>Instance of the FieldInfoProvider.</returns>
        public static IFieldInfoProvider GetInstance()
        {
            return _providerInstance;
        }
    }

    /// <summary>Actual implementation of the FieldInfoProvider. Used by singleton wrapper.</summary>
    internal class FieldInfoProviderCore : FieldInfoProviderBase
    {
        /// <summary>Initializes a new instance of the <see cref="FieldInfoProviderCore"/> class.</summary>
        internal FieldInfoProviderCore()
        {
            Init();
        }

        /// <summary>Method which initializes the internal datastores.</summary>
        private void Init()
        {
            this.InitClass((6 + 3));
            InitDerdeBeheerderStraatEntityInfos();
            this.ConstructElementFieldStructures(InheritanceInfoProviderSingleton.GetInstance());
        }
        /// <summary>Inits DerdeBeheerderStraatEntity's FieldInfo objects</summary>
        private void InitDerdeBeheerderStraatEntityInfos()
        {
            this.AddFieldIndexEnumForElementName(typeof(DerdeBeheerderStraatFieldIndex), "DerdeBeheerderStraatEntity");
            this.AddElementFieldInfo("DerdeBeheerderStraatEntity", "DtTot", typeof(Nullable<System.DateTime>), false, false, false, true, (int)DerdeBeheerderStraatFieldIndex.DtTot, 0, 0, 0);
            this.AddElementFieldInfo("DerdeBeheerderStraatEntity", "DtWijz", typeof(System.DateTime), false, false, false, false, (int)DerdeBeheerderStraatFieldIndex.DtWijz, 0, 0, 0);
            this.AddElementFieldInfo("DerdeBeheerderStraatEntity", "HistInd", typeof(System.String), false, false, false, true, (int)DerdeBeheerderStraatFieldIndex.HistInd, 1, 0, 0);
            this.AddElementFieldInfo("DerdeBeheerderStraatEntity", "Id", typeof(System.Int64), true, false, false, false, (int)DerdeBeheerderStraatFieldIndex.Id, 0, 0, 10);
            this.AddElementFieldInfo("DerdeBeheerderStraatEntity", "OldId", typeof(Nullable<System.Int64>), false, false, false, true, (int)DerdeBeheerderStraatFieldIndex.OldId, 0, 0, 10);
            this.AddElementFieldInfo("DerdeBeheerderStraatEntity", "PostCd", typeof(System.String), false, false, false, false, (int)DerdeBeheerderStraatFieldIndex.PostCd, 15, 0, 0);
            this.AddElementFieldInfo("DerdeBeheerderStraatEntity", "Straat", typeof(System.String), false, false, false, false, (int)DerdeBeheerderStraatFieldIndex.Straat, 100, 0, 0);
            this.AddElementFieldInfo("DerdeBeheerderStraatEntity", "StraatCd", typeof(System.String), false, false, false, true, (int)DerdeBeheerderStraatFieldIndex.StraatCd, 10, 0, 0);
            this.AddElementFieldInfo("DerdeBeheerderStraatEntity", "TaalCd", typeof(System.String), false, false, false, false, (int)DerdeBeheerderStraatFieldIndex.TaalCd, 10, 0, 0);
            this.AddElementFieldInfo("DerdeBeheerderStraatEntity", "UsidWijz", typeof(System.String), false, false, false, false, (int)DerdeBeheerderStraatFieldIndex.UsidWijz, 10, 0, 0);
        }
    }
    public enum DerdeBeheerderStraatFieldIndex
    {
        ///<summary>DtTot. </summary>
        DtTot,
        ///<summary>DtWijz. </summary>
        DtWijz,
        ///<summary>HistInd. </summary>
        HistInd,
        ///<summary>Id. </summary>
        Id,
        ///<summary>OldId. </summary>
        OldId,
        ///<summary>PostCd. </summary>
        PostCd,
        ///<summary>Straat. </summary>
        Straat,
        ///<summary>StraatCd. </summary>
        StraatCd,
        ///<summary>TaalCd. </summary>
        TaalCd,
        ///<summary>UsidWijz. </summary>
        UsidWijz,
        /// <summary></summary>
        AmountOfFields
    }
}
