﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using Microsoft.Practices.Prism.ViewModel;
using SD.LLBLGen.Pro.ORMSupportClasses;
namespace XamDataGridSelectActiveRow
{
 
public class ViewModel : NotificationObject
    {
        private EntityCollection<DerdeBeheerderStraatEntity> _results;

        public EntityCollection<DerdeBeheerderStraatEntity> Results
        {
            get { return _results; }
            set { _results = value; RaisePropertyChanged(() => Results); }
        }
        private DerdeBeheerderStraatEntity _currentRow;

        public DerdeBeheerderStraatEntity CurrentRow
        {
            get { return _currentRow; }
            set
            {
                if (value != null)
                {
                    _currentRow = value;
                    RaisePropertyChanged(() => CurrentRow);
                }
            }
        }

        int cnt = 0;

        public ViewModel()
        {
            CreateData();
        }

       

        private string[] names = { "John", "Kim", "Sandy", "Mark", "Josh", "Jim", "Sam", "Mary", 
                                     "Harry", "Sue", "Chris", "Joe", "Carl" };
        private string[] recDescs = { "Test", "Duplicate", "Standard", "Trial", "Expired", "New", "History" };
        private void CreateData()
        {
            Random r = new Random();
            Results = new EntityCollection<DerdeBeheerderStraatEntity>();
            for (int i = 0; i < 20; i++)
            {
                Results.Add(new DerdeBeheerderStraatEntity()
                {
                    Id = i,
                    Straat = names[r.Next(13)],
                    DtTot = DateTime.Today.AddDays(r.Next(10)),
                });
            }

            cnt = 19;
            //CurrentRow = Results.FirstOrDefault();
        }

        public void AddData()
        {
            var currItem = CurrentRow;
            var backupRes = Results;
            Results = null;
            //Simulation of what might happen during add.
            var copyRes = new EntityCollection<DerdeBeheerderStraatEntity>(); // Data is sent to server and back so
                                                                              // collection object is new
            foreach (var row in backupRes)                                    // Same goes for the entities
                copyRes.Add(new DerdeBeheerderStraatEntity()                
                {
                    Id = row.Id,
                    Straat = row.Straat,
                    DtTot = row.DtTot
                });
            cnt++;
            Random r = new Random();
            copyRes.Add(new DerdeBeheerderStraatEntity()
            {
                Id = cnt,
                Straat = names[r.Next(13)],
                DtTot = DateTime.Today.AddDays(r.Next(10)),
            });
            
            //End simulation, copyRes is returned.
            Results = copyRes;
            foreach(var row in Results)
            {
                if (row.Id == currItem.Id)
                {
                    CurrentRow = row;
                    break;
                }
            }
        }

        public void UpdateData()
        {
            var currItem = CurrentRow;
            var backupRes = Results;
            Results = null;
            //Simulation of what might happen during add.
            Random r = new Random();
            int recID = r.Next(cnt - 1);
            DerdeBeheerderStraatEntity gd = (from rec in backupRes
                          where rec.Id == recID
                          select rec).FirstOrDefault();



            gd.Straat = gd.Straat + " - Updated";
            gd.DtTot = DateTime.Today.AddDays(r.Next(10));
            //End simulation, backupRes is returned.
            Results = backupRes;
            CurrentRow = currItem;
            
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }


        internal void SaveData()
        {
            throw new NotImplementedException();
        }
    }
    public class GridData : EntityBase2, INotifyPropertyChanged, IEntity2
    {
        
        private int id;
        private string name;
        private DateTime recDt;
        private string rec_desc;


        public int ID
        {
            get { return id; }
            set
            {
                if (id != value)
                {
                    id = value;
                    OnPropertyChanged("ID");
                }
            }
        }

        public string Name
        {
            get { return name; }
            set
            {
                if (name != value)
                {
                    name = value;
                    OnPropertyChanged("Name");
                }
            }
        }

        public string RecDesc
        {
            get { return rec_desc; }
            set
            {
                if (rec_desc != value)
                {
                    rec_desc = value;
                    OnPropertyChanged("RecDesc");
                }
            }
        }

        public DateTime RecDate
        {
            get { return recDt; }
            set
            {
                if (recDt != value)
                {
                    recDt = value;
                    OnPropertyChanged("RecDate");
                }
            }
        }



        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        internal GridData Clone()
        {
            GridData res = new GridData();
            res.ID = this.ID;
            res.Name = this.Name;
            res.RecDate = this.RecDate;
            res.RecDesc = this.RecDesc;
            return res;
        }

        protected override System.Collections.Generic.List<IEntity2> GetDependentRelatedEntities()
        {
            return new List<IEntity2>();
        }

        protected override System.Collections.Generic.List<IEntity2> GetDependingRelatedEntities()
        {
            return new List<IEntity2>();
        }

        protected override System.Collections.Generic.List<IEntityCollection2> GetMemberEntityCollections()
        {
            return new List<IEntityCollection2>();
        }

        protected override System.Collections.Generic.Dictionary<string, string> CustomPropertiesOfType
        {
            get { return new Dictionary<string, string>(); }
        }

        protected override System.Collections.Generic.Dictionary<string, System.Collections.Generic.Dictionary<string, string>> FieldsCustomPropertiesOfType
        {
            get { return new Dictionary<string, Dictionary<string,string>>(); }
        }

        protected override System.Collections.Generic.List<IEntityRelation> GetAllRelations()
        {
            return new List<IEntityRelation>();
        }

        protected override System.Collections.Generic.Dictionary<string, object> GetRelatedData()
        {
            return new Dictionary<string,object>();
        }

        protected override RelationCollection GetRelationsForFieldOfType(string fieldName)
        {
            return new RelationCollection();
        }

        protected override void SetRelatedEntity(IEntityCore relatedEntity, string fieldName)
        {
            
        }

        protected override void UnsetRelatedEntity(IEntityCore relatedEntity, string fieldName, bool signalRelatedEntityManyToOne)
        {
        }
    }
}